// HPSelectionSet.cpp : implementation of the HPSelectionSet class
// 

#include "HPSelectionSet.h"
#include "hc.h"
#include "hp_bridge.h"
#include "assert.h"

#include "HParaModel.h"
#include "HParaView.h"


HPSelectionSet::HPSelectionSet()
{
	m_SelectLevel = PK_CLASS_body;	// set default level to body
}


HPSelectionSet::~HPSelectionSet()
{
}


void HPSelectionSet::Select(long key, char* segpath, long include_key, long includer_key)
{
	PK_ENTITY_t	entity = 0;
	HC_KEY keys[40000];
	int count, c;
	char value[4];

	// determine the tagid of the parasolid entity based on the first elt in the selection list
	entity = HP_Compute_TagID(key, m_SelectLevel);

	if (entity <= 0) return;

	// compute all the HOOPS geometry assoicated with the Parasolid entity

	HP_Show_One_Mapping_Option("create body segments",value);	
	if ((m_SelectLevel == PK_CLASS_body) && strstr(value,"on"))
	{
		count = HP_Compute_Geometry_Keys(entity, keys, "bodies=on", 40000);
	}
	else
		count = HP_Compute_Geometry_Keys(entity, keys, "edges=on , faces=on", 40000);

	assert(count < 40000);
	for (c = 0; c < count; c++)
	{
		HSelectionSet::Select(keys[c], segpath, NULL, NULL);  // call base class fcn for each key
	}

	
}


void HPSelectionSet::DeSelect(long key)
{
	PK_ENTITY_t	entity = 0;
	HC_KEY keys[40000];
	int count, c;
	char value[4];

	// determine the tagid of the parasolid entity based on the first elt in the selection list
	entity = HP_Compute_TagID(key, m_SelectLevel);

	assert(entity > 0);

	// compute all the HOOPS geometry assoicated with the Parasolid entity
	
	HP_Show_One_Mapping_Option("create body segments",value);
	if ((m_SelectLevel == PK_CLASS_body) && strstr(value,"on"))

	{
		count = HP_Compute_Geometry_Keys(entity, keys, "edges=on , faces=on", 40000);
	}
	else
		count = HP_Compute_Geometry_Keys(entity, keys, "edges=on , faces=on", 40000);

	assert(count < 40000);
	for (c = 0; c < count; c++)
	{
		HSelectionSet::DeSelect(keys[c]);	// call base class fcn for each key
	}


}

bool HPSelectionSet::IsSelected(long key)
{
	// determine the tagid of the parasolid entity based on the first elt in the selection list
	char value[4];

	if (key > 0)
	{
		HP_Show_One_Mapping_Option("create body segments",value);
		if ((m_SelectLevel == PK_CLASS_body) && strstr(value,"on"))

		{
			key = (long)HP_Compute_TagID(key, m_SelectLevel);
			assert(HC_Show_Existence_By_Key(key, "self"));
		}
	}

    // call base class function with the computed key
	return HSelectionSet::IsSelected(key);
}


	